package {{.Option "name"}}

import (
	"shylinux.com/x/ice"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/enterprise/src/guanlixitong"
	"{{.Option "module"}}/model"
)

type Tables struct {
	guanlixitong.Tables
	list string `name:"list {{.Option "class"}}_uid uid auto" role:"void"`
}
type Table struct {
	guanlixitong.Table
	list string `name:"list {{.Option "class"}}_uid uid auto" role:"void"`
}

func (s Table) Inputs(m *ice.Message, arg ...string) {
	switch arg[0] {
	case model.{{.Option "CLASS"}}_TYPE:
		for k, v := range {{.Option "Class"}}TypeList {
			m.Push(arg[0], k).Push(model.NAME, v)
		}
		m.SortInt(arg[0]).DisplayInputKeyNameIconTitle()
	case model.USER_{{.Option "CLASS"}}_ROLE:
		for k, v := range User{{.Option "Class"}}RoleList {
			if k != User{{.Option "Class"}}Creator && k != User{{.Option "Class"}}Visitor {
				m.Push(arg[0], k).Push(model.NAME, v)
			}
		}
		m.SortInt(arg[0]).DisplayInputKeyNameIconTitle()
	default:
		s.Table.Inputs(m, arg...)
	}
}
func (s Table) RewriteAppend(m *ice.Message, arg ...string) *ice.Message {
	m.RewriteAppend(func(value, key string, index int) string {
		kit.If(key == model.{{.Option "CLASS"}}_TYPE, func() { value = {{.Option "Class"}}Type(kit.Int(value)).String() })
		kit.If(key == model.USER_{{.Option "CLASS"}}_ROLE, func() { value = User{{.Option "Class"}}Role(kit.Int(value)).String() })
		return value
	})
	s.Table.RewriteAppend(m)
	return m
}
