package {{.Option "name"}}

import (
	"shylinux.com/x/ice"

	"{{.Option "module"}}/model"
)

type user{{.Option "Class"}} struct {
	Table
	{{.Option "class"}}  {{.Option "class"}}
}

func (s user{{.Option "Class"}}) User(m *ice.Message, arg ...string) {
	if len(arg) == 1 {
		s.Select(m, model.{{.Option "CLASS"}}_UID, arg[0])
	} else if len(arg) == 2 {
		s.Select(m, model.{{.Option "CLASS"}}_UID, arg[0], model.UID, arg[1])
	} else {
		return
	}
	m.RenameAppend(model.ROLE, model.USER_{{.Option "CLASS"}}_ROLE)
	s.SelectJoinUser(m)
	s.RewriteAppend(m)
}
func (s user{{.Option "Class"}}) List(m *ice.Message, arg ...string) {
	s.Tables(m, s.{{.Option "class"}}).FieldsWithCreatedAT(m, s,
		model.{{.Option "CLASS"}}_NAME, model.{{.Option "CLASS"}}_TYPE, model.USER_{{.Option "CLASS"}}_ROLE,
		model.{{.Option "CLASS"}}_UID, model.COMPANY_UID,
	)
	if len(arg) == 1 {
		s.Select(m, model.USER_UID, arg[0])
	} else if len(arg) == 2 {
		s.SelectDetail(m, model.USER_UID, arg[0], s.Key(s.{{.Option "class"}}, model.UID), arg[1])
	} else {
		return
	}
	s.SelectJoinCompany(m)
	s.SelectJoinCity(m)
	s.RewriteAppend(m)
}

func init() { ice.TeamCtxCmd(user{{.Option "Class"}}{}) }

type User{{.Option "Class"}}Role int

const (
	User{{.Option "Class"}}Creator User{{.Option "Class"}}Role = iota
	User{{.Option "Class"}}Visitor
)

var User{{.Option "Class"}}RoleList = map[User{{.Option "Class"}}Role]string{
	User{{.Option "Class"}}Creator: "creator",
	User{{.Option "Class"}}Visitor: "visitor",
}

func (s User{{.Option "Class"}}Role) String() string { return User{{.Option "Class"}}RoleList[s] }
