package yuehaoxitong

import (
	"shylinux.com/x/ice"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/community/src/yuehaoxitong/model"
	"shylinux.com/x/enterprise/src/guanlixitong"
)

type Tables struct {
	guanlixitong.Tables
	list string `name:"list queue_uid uid auto" role:"void"`
}

func (s Tables) CheckRole(m *ice.Message, arg ...UserQueueRole) bool {
	return Table{}.CheckRole(m, arg...)
}
func (s Tables) RewriteAppend(m *ice.Message, arg ...string) *ice.Message {
	return Table{}.RewriteAppend(m, arg...)
}

type Table struct {
	guanlixitong.Table
	list string `name:"list queue_uid uid auto" role:"void"`
}

func (s Table) Inputs(m *ice.Message, arg ...string) {
	switch arg[0] {
	case model.QUEUE_TYPE:
		for k, v := range QueueTypeList {
			m.Push(arg[0], k).Push(model.NAME, v)
		}
		m.SortInt(arg[0]).DisplayInputKeyNameIconTitle()
	case model.USER_QUEUE_ROLE:
		for k, v := range UserQueueRoleList {
			if k != UserQueueCreator && k != UserQueueVisitor {
				m.Push(arg[0], k).Push(model.NAME, v)
			}
		}
		m.SortInt(arg[0]).DisplayInputKeyNameIconTitle()
	default:
		s.Table.Inputs(m, arg...)
	}
}
func (s Table) CheckRole(m *ice.Message, arg ...UserQueueRole) bool {
	kit.If(len(arg) == 0, func() { arg = append(arg, UserQueueCreator, UserQueueManager) })
	role := UserQueueRole(kit.Int(m.Cmd(userQueue{}, s.Select, m.OptionSimple(model.QUEUE_UID, model.USER_UID)).Append(model.ROLE)))
	for _, v := range arg {
		if role == v {
			return true
		}
	}
	return false
}
func (s Table) RewriteAppend(m *ice.Message, arg ...string) *ice.Message {
	m.RewriteAppend(func(value, key string, index int) string {
		kit.If(key == model.QUEUE_TYPE, func() { value = QueueType(kit.Int(value)).String() })
		kit.If(key == model.USER_QUEUE_ROLE, func() { value = UserQueueRole(kit.Int(value)).String() })
		kit.If(key == model.SCHEDULE_STATUS, func() { value = ScheduleStatus(kit.Int(value)).String() })
		return value
	})
	s.Table.RewriteAppend(m)
	return m
}
