package yuehaoxitong

import (
	"shylinux.com/x/ice"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/community/src/yuehaoxitong/model"
)

type plan struct {
	Tables
	volume   volume
	schedule schedule
	create   string `name:"create reception_uid* volume_uid*" role:"void"`
	cancel   string `name:"cancel" role:"void"`
}

func (s plan) Create(m *ice.Message, arg ...string) {
	m.Cmd(s.schedule, s.Create, arg, m.OptionSimple(model.QUEUE_UID, model.USER_UID), model.STATUS, SchedulePlan)
}
func (s plan) Cancel(m *ice.Message, arg ...string) {
	m.Cmd(s.schedule, s.Cancel)
}
func (s plan) List(m *ice.Message, arg ...string) {
	m.Cmdy(s.schedule, s.schedule.SelectByStatus, arg[0], SchedulePlan, m.OptionSimple(model.USER_UID)).PushAction(s.Cancel)
	kit.If(m.Length() == 0, func() { m.EchoInfoButton(m.Trans("please create schedule", "请创建预约"), s.Create) })
}

func init() { ice.TeamCtxCmd(plan{}) }
