package yuehaoxitong

import (
	"shylinux.com/x/ice"
	"shylinux.com/x/icebergs/base/mdb"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/community/src/yuehaoxitong/model"
)

type reception struct {
	Table
	userQueue userQueue
	portal    string `data:"true"`
	create    string `name:"create name*" role:"void"`
	rename    string `name:"rename name*" role:"void"`
	delete    string `name:"delete" role:"void"`
}

func (s reception) Create(m *ice.Message, arg ...string) {
	if !m.WarnNotRight(!s.CheckRole(m)) {
		s.Table.Create(m, append(arg, m.OptionSimple(model.QUEUE_UID)...)...)
		s.RecordEvent(m, m.Option(model.QUEUE_UID), kit.Format(m.Trans("create reception %s", "创建服务接待 %s"), m.Option(mdb.NAME)), arg...)
	}
}
func (s reception) Rename(m *ice.Message, arg ...string) {
	if !m.WarnNotRight(!s.CheckRole(m)) {
		s.Table.Rename(m.Spawn())
		s.RecordEvent(m, m.Option(model.QUEUE_UID), kit.Format(m.Trans("rename reception %s", "重命名服务接待 %s"), m.Option(mdb.NAME)), arg...)
	}
}
func (s reception) Delete(m *ice.Message, arg ...string) {
	if !m.WarnNotRight(!s.CheckRole(m)) {
		s.Table.Delete(m.Spawn(), m.OptionSimple(model.UID)...)
		s.RecordEvent(m, m.Option(model.QUEUE_UID), kit.Format(m.Trans("delete reception %s", "删除服务接待 %s"), m.Option(mdb.NAME)), arg...)
	}
}
func (s reception) List(m *ice.Message, arg ...string) {
	s.Table.Fields(m, model.UID, model.NAME, model.CREATED_AT)
	if len(arg) == 0 {
		if m.Option(model.QUEUE_UID) != "" {
			s.Table.Select(m, m.OptionSimple(model.QUEUE_UID)...)
		}
	} else if len(arg) == 1 {
		s.Table.Select(m, model.QUEUE_UID, arg[0]).Action(s.Create)
	} else if len(arg) == 2 {
		s.Table.SelectDetail(m, model.QUEUE_UID, arg[0], model.UID, arg[1])
	}
	m.PushAction(s.Rename, s.Delete)
}

func init() { ice.TeamCtxCmd(reception{}) }
